/**
 * Copyright 2010 Västra Götalandsregionen
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of version 2.1 of the GNU Lesser General Public
 *   License as published by the Free Software Foundation.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 *   Boston, MA 02111-1307  USA
 */

package se.vgregion.verticalprio.controllers;

import java.util.regex.Pattern;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

@Controller
public class TreeViewController {

	@RequestMapping(value = { "treeView" })
	public String render(@RequestParam Integer id, @RequestParam String allObjects) {

		return "treeView";
	}

	private String toByteText(byte[] bytes) {
		StringBuilder sb = new StringBuilder();

		for (byte b : bytes) {
			sb.append(b + "b");
		}
		return sb.toString();
	}

	private byte[] toBytes(String byteText) {
		String[] frags = byteText.split(Pattern.quote("b"));
		byte[] result = new byte[frags.length];
		int i = 0;
		for (String frag : frags) {
			result[i] = Byte.parseByte(frag);
			i++;
		}
		return result;
	}

}
